xref: /freebsd/tools/test/stress2/misc/cleanup.sh (revision 81ad6265)
1#!/bin/sh
2
3#
4# Copyright (c) 2008-2013 Peter Holm <pho@FreeBSD.org>
5# All rights reserved.
6#
7# Redistribution and use in source and binary forms, with or without
8# modification, are permitted provided that the following conditions
9# are met:
10# 1. Redistributions of source code must retain the above copyright
11#    notice, this list of conditions and the following disclaimer.
12# 2. Redistributions in binary form must reproduce the above copyright
13#    notice, this list of conditions and the following disclaimer in the
14#    documentation and/or other materials provided with the distribution.
15#
16# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
17# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
18# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
19# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
20# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
21# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
22# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
23# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
24# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
25# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
26# SUCH DAMAGE.
27#
28
29[ `id -u ` -ne 0 ] && echo "Must be root!" && exit 1
30
31. ../default.cfg
32
33bname=`basename $mntpoint`
34mounts=`mount | awk "/$bname/{print \\$3}"`
35nmounts=`sysctl -n hw.ncpu`		# Max number of mounts in use
36[ $nmounts -lt 31 ] && nmounts=31	# Arbitrary value
37s=0
38# Unmount the test mount points: /mnt, /mnt10 .. mnt31
39for i in $mounts; do
40	u=`echo $i | sed "s/\/$bname//"`
41	[ -z "$u" ] && u=$mdstart
42	echo "$u" | grep -Eq '^[0-9]+$' || continue
43#	[ $u -lt $mdstart -o $u -gt $((mdstart + nmounts)) ] && continue
44	while mount | grep -q "on $i "; do
45		r=`fstat -mf $i 2>/dev/null | awk '$3 ~ /^[0-9]+$/ {print $3}'`
46		if [ -n "$r" ]; then
47			echo "cleanup.sh: kill $r"
48			echo $r | xargs kill; sleep 1
49		fi
50		echo "cleanup.sh: umount -f $i"
51		umount -f $i > /dev/null 2>&1 || s=1
52		[ -z "$r" ] && break
53	done
54done
55
56# Delete the test mount points /mnt10 .. /mnt31
57for i in `ls -d $mntpoint* 2>/dev/null | grep -Ev '^$mntpoint$'`; do
58	u=`echo $i | sed "s/\/$bname//"`
59	echo "$u" | grep -Eq '^[0-9]+$' || continue
60#	[ $u -lt $mdstart -o $u -gt $((mdstart + nmounts)) ] && continue
61	if ! mount | grep -q "on $i "; then
62		[ -d $i ] && find $i -delete \
63			2>/dev/null
64		rm -rf $i > /dev/null 2>&1
65	fi
66done
67
68# Delete the memory disks
69units=`mdconfig -l | sed 's/md//g'`
70for u in $units; do
71	if [ $u -ge $mdstart -a $u -lt $((mdstart + nmounts)) ]; then
72		echo "cleanup.sh: mdconfig -d -u $u"
73		mdconfig -d -u $u || s=1
74		[ -c /dev/md$u ] && sleep .1
75	fi
76done
77
78[ -d "$mntpoint" ] && (cd $mntpoint && find . -delete)
79rm -f /tmp/.snap/stress2* /var/.snap/stress2*
80rm -rf /tmp/stressX.control $RUNDIR
81[ -d `dirname "$diskimage"` ] || mkdir -p `dirname "$diskimage"`
82mkdir -p $RUNDIR
83chmod 0777 $RUNDIR
84
85# Delete $testuser's ipcs
86ipcs | awk "\$5 ~/$testuser/ && \$6 ~/$testuser/ {print \"-\" \$1,\$2}" | \
87    xargs -t ipcrm
88
89# Modules
90#mlist=/tmp/stress2.d/mlist
91#find $mlist -mtime +1 -delete 2>/dev/null
92#[ -f $mlist ] && touch $mlist ||
93#    { kldstat | kldstat | awk '/\.ko$/ {print $NF}' > $mlist; \
94#    echo "Updating $mlist"; }
95#for m in `kldstat | awk '/\.ko$/ {print $NF}'`; do
96#	grep -q $m $mlist && continue
97#	echo "pty.ko mqueuefs.ko ioat.ko ums.ko" | grep -q $m && continue
98#	echo "cleanup.sh: kldunload $m"
99#	kldunload $m
100#done
101# unloading an active dtrace causes a panic
102#kldstat | grep -q dtraceall.ko && kldunload dtraceall.ko
103kldstat | grep -q ext2fs.ko && kldunload ext2fs.ko
104[ $s -ne 0 ] && echo "cleanup.sh: FAIL $s"
105exit $s
106